#ifdef _WIN32
 #define BIGENDIAN(x) (((x & 0x00FF)<<8) | ((x & 0xFF00)>>8))
 #define CODERAMROM
#else
 #define BIGENDIAN(x) (x)
 #define CODERAMROM const
#endif



#define MAX_KEYS 16
#define MAX_DINPUTS 4
#define MAX_AINPUTS 4
#define MAX_STATEMACHINES 256
#define MAX_RELAYS 16
#define MAX_CODE 16384


#define NOTYP 0
#define KEYCLICK 1
#define KEYPRESSED 2
#define KEYRELEASED 3
#define KEYRELEASETIME 4
#define KEYDOWN 5
#define KEYDOWNTIME 6
#define KEYUP 7
#define DINPUTLOW 8
#define DINPUTHIGH 9
#define DINPUTLH 10
#define DINPUTHL 11
#define AINPUT 12
#define RELAY 13
#define STATE 14
#define STATETIME 15
#define VARIABLE 16


#define COMPNOTDEFINED 0
#define NEVER 1
#define ALLWAYS 2
#define EQUAL 3
#define UNEQUAL 4
#define GREATER 5
#define SMALLER 6
#define EQUAL_OR_GREATER 7
#define EQUAL_OR_SMALLER 8


typedef struct{
  unsigned char pressed       :1;
  unsigned char released      :1;
  unsigned char down          :1;
  unsigned char clickdetected :1;
  unsigned char reserved      :4;
  unsigned char time          ;
}t_key;

typedef struct{
  unsigned char lh            :1;
  unsigned char hl            :1;
  unsigned char high          :1;
  unsigned char old           :1;
  unsigned char reserved      :4;
}t_dinput;

typedef struct{
  unsigned char val;
}t_ainput;

typedef struct{
  unsigned char state;
  unsigned char laststate;
  unsigned char has_changed;
  unsigned short int time;
}t_statemachine;

typedef struct{
  unsigned char active        :1;
  unsigned char old           :1;
  unsigned char breakbmake    :1;
  unsigned char reserved      :5;
}t_relay;


typedef struct{
  unsigned char version;
  unsigned char reserved1;
  unsigned short int length;
  unsigned char statemachines;
  unsigned char initstate[MAX_STATEMACHINES];
  char filename[64];
  char datestring[32];
  unsigned char reserved2[1024];
  unsigned char bytes[0];
}t_codeheader;


typedef struct{
  unsigned char obj_typ;
  unsigned char obj_nr;
}t_object;


typedef struct{
  t_object object;
  short int compvalue;
  unsigned char comptyp;
}t_compares;
#define SIZE_COMPARE 5

typedef struct{
  unsigned char ands;
  unsigned char andcompares[0];
}t_or_compares;
#define SIZE_OR_COMPARE 1

typedef struct{
  short int val;
  unsigned char ors;
  t_object object;
  unsigned char orcompares[0];
}t_actions;
#define SIZE_ACTION 5


extern CODERAMROM unsigned char code[MAX_CODE];

void Key_Down(int i);
void Key_Up(int i);
void Task100ms(void);

void SetRelais(unsigned char i,unsigned char state);
void Interpret(void);
void InitInterpreter(void);
void SetDInput(int i,unsigned char val);
void SetAInput(int i,unsigned char val);
void Task50ms(void);
void Task100ms_A(void);
void Task100ms_B(void);
